Subject: GMPLS TLV Format

From: "Adrian Farrel" <[email-masked]>
Date: Mon, 10 Mar 2008 20:02:21 -0000

Hi,

In today's meeting, we discussed again the issue of TLV formats in:

- RFC 3209 and RFC 3471
- RFC 4420
- draft-ietf-ccamp-ethernet-traffic-parameters-03.txt

The current position is:
- Base RSVP-TE and GMPLS carry the full length of the
  TLV in the Length field
- OSPF carries the length of the Value field only in the
  TLV
- RFC 4420 follows the OSPF form. This was an error
   that was not intended.
- draft-ietf-ccamp-ethernet-traffic-parameters followed
   RFC 4420 (assuming that the WG had made a deliberate
   change)

The bottom line is that it is not helpful to implementers that one protocol 
has two different ways to encode TLVs.

We must choose between three options.
1. All TLVs are encoded as per RFC 3209.
    RFC 4420 would need to be fixed.
   draft-ietf-ccamp-ethernet-traffic-parameters would
    need to be changed.
2. All TLVs *except* those in RFC 4420 use the
    RFC 3209 format. RFC 4420 remains an anomaly.
3. All old TLVs remain as per RFC 3209. All new
    TLVs (starting from RFC 4420) use the RFC 4420
    format.

The meeting seemed to prefer option 1, but this is contingent on existing 
implementations. If there are too many existing and deployed implementations 
(too many == 1 ?) we may have to pick to option 2.

So...

How would you feel if we did an update to RFC 4420 that fixed the TLV 
encoding to be conformant with RFC 3209? Would this cause any of you a 
problem?

Reply on-list or to me in private if there is a confidentiality issue.

It would be helpful to have opinions on both sides. Please don't leave 
silence to mean anything specific.

Thanks,
Adrian

---

From: Lou Berger <[email-masked]>
Date: Mon, 10 Mar 2008 16:37:35 -0400

Just to avoid any possible silence:

I think fixing RFC 4420 *quickly* would be best.

Lou

At 04:02 PM 3/10/2008, Adrian Farrel wrote:
>The bottom line is that it is not helpful to implementers that one 
>protocol has two different ways to encode TLVs.
>
>The meeting seemed to prefer option 1, but this is contingent on 
>existing implementations. If there are too many existing and 
>deployed implementations (too many == 1 ?) we may have to pick to option 2.
>
>So...
>
>How would you feel if we did an update to RFC 4420 that fixed the 
>TLV encoding to be conformant with RFC 3209? Would this cause any of 
>you a problem?
>
>It would be helpful to have opinions on both sides. Please don't 
>leave silence to mean anything specific.
>
>Thanks,
>Adrian
>
>
>

---

From: "Drake, John E" <[email-masked]>
Date: Mon, 10 Mar 2008 16:29:27 -0700

Indeed 

>-----Original Message-----
>From: Lou Berger [mailto:[email-masked]] 
>Sent: Monday, March 10, 2008 1:38 PM
>To: Adrian Farrel
>Cc: [email-masked]
>Subject: Re: GMPLS TLV Format
>
>>existing implementations. If there are too many existing and deployed 
>>implementations (too many == 1 ?) we may have to pick to option 2.
>>
>>So...
>>

---

From: <[email-masked]>
Date: Tue, 11 Mar 2008 15:12:03 +0100

Hi.

Agreed.

But do you think a draft 4420bis "Created: March 11" and dated "03-10"
on the CCAMP status page will be fast enough to progress back to 4420
publishing ages? ;-)

Julien

-----Original Message-----
From: [email-masked] [mailto:[email-masked]] On
Behalf Of Lou Berger

Lou